<?php
// Copyright 1999-2015. Parallels IP Holdings GmbH. All Rights Reserved.

class CreateScheduledTasks extends Upgrader\Migration
{
    public function change()
    {
        $this->createTable('ScheduledTasks', [
            'description' => 'Scheduled tasks storage',
            'columns' => [
                'id' => self::TYPE_PRIMARY_KEY,
                'hash' => self::TYPE_STRING,
                'serviceNodeId' => [
                    'type' => self::TYPE_FOREIGN_KEY,
                    'foreignKey' => 'ServiceNodes.id',
                    'deleteCascade' => true,
                ],
                'sysUserId' => [
                    'type' => self::TYPE_FOREIGN_KEY,
                    'notNull' => false,
                    'foreignKey' => 'sys_users.id',
                    'deleteCascade' => true,
                ],
                'sysUserLogin' => [
                    'type' => self::TYPE_STRING,
                    'notNull' => false,
                ],
                'isActive' => self::TYPE_BOOLEAN,
                'type' => [
                    'type' => self::TYPE_ENUM,
                    'values' => ['exec', 'http', 'php'],
                    'default' => 'exec',
                ],
                'phpHandlerId' => [
                    'type' => self::TYPE_STRING,
                    'notNull' => false,
                ],
                'command' => self::TYPE_STRING,
                'arguments' => self::TYPE_STRING,
                'description' => [
                    'type' => self::TYPE_STRING,
                    'notNull' => false,
                ],
                'notify' => [
                    'type' => self::TYPE_ENUM,
                    'values' => ['ignore', 'errors', 'always'],
                    'default' => 'ignore',
                ],
                'emailType' => [
                    'type' => self::TYPE_ENUM,
                    'values' => ['default', 'owner', 'custom'],
                    'default' => 'owner',
                ],
                'email' => self::TYPE_STRING,
                'minute' => self::TYPE_STRING,
                'hour' => self::TYPE_STRING,
                'dayOfMonth' => self::TYPE_STRING,
                'month' => self::TYPE_STRING,
                'dayOfWeek' => self::TYPE_STRING,
                'period' => self::TYPE_INTEGER,
            ],
            'indexes' => [
                'serviceNodeId' => [
                    'type' => self::INDEX_KEY,
                    'columns' => ['serviceNodeId'],
                ],
                'sysUserId' => [
                    'type' => self::INDEX_KEY,
                    'columns' => ['sysUserId'],
                ],
            ],
        ]);
    }
}
